package com.climber;

import java.util.ArrayList;
import java.util.Collections;


public class ScoreManager {
	private ArrayList<Float> m_scores; //where all of the scores are held
	private int m_numOfScores; //the max amount of scores to keep
	
	
	public ScoreManager(int num) {
		m_numOfScores = num;
		m_scores = new ArrayList<Float>();
	}
	
	/**
	 * Adds a new score to the list of high scores. If the score doesn't  make it into the top, it isn't added.
	 * @param score The score to add
	 * @return True if the score made it into the high scores, false if it didn't.
	 */
	public boolean addScore(Float score) {
		if (m_scores.size() == 0) {
			m_scores.add(score);
			return true;
		}
		
		m_scores.add(score);
		Collections.sort(m_scores);
		Collections.reverse(m_scores);
		
		if ( m_scores.size() > m_numOfScores) {
			for ( int i = m_numOfScores; m_scores.size() > i;  ) {
				m_scores.remove(i);
			}
		}
		
		return (m_scores.contains(score));
	}
	
	public float getTopScore() {
		return (Float) m_scores.get(0);
	}
	
	public String toString() {
		String toReturn = "";
		
		for ( int i = 0; i < m_scores.size(); i++) {
			toReturn += m_scores.get(i).toString() + '\n';
		}
		
		return toReturn;
	}
	
	public void importFromString(String data) {
		String[] scores = data.split("\n");
		for ( int i = 0; i < scores.length; i++ ) {
			Float f = Float.parseFloat(scores[i]);
			m_scores.add(f);
		}
	}
}
